<template>
  <div style="width: 100%; height: 100%;">
    <div class="here_map_frame__gradient"></div>
    <div ref="mapContainer" style="width: 100%; height: 100%;"></div>
  </div>
</template>
<script>
export default {
  data: function() {
    return {
      mapObj: false,
      user: false,
    };
  },
  mounted: function() {
    this.initMap();
  },
  watch: {
    position: function(current, prev) {
      if (this.position && this.mapObj) {
        this.mapObj.setCenter({
          lat: this.position.coords.latitude,
          lng: this.position.coords.longitude,
        });
        this.user.setPosition({
          lat: this.position.coords.latitude,
          lng: this.position.coords.longitude,
        });
      }
    },
  },

  computed: {
    position: function() {
      return this.$store.getters.getPosition;
    },
  },
  methods: {
    initMap: function() {
      // Initialize the platform object:
      var platform = new H.service.Platform({
        app_id: "acG6wu3lEemv7kBZMfFx",
        app_code: "ffJ9HkssdH3W1I_drrmmhQ",
        useHTTPS: true,
      });
      var maptypes = platform.createDefaultLayers({ lg: "RUS" });
      var coords = {
        lng: this.position.coords.longitude,
        lat: this.position.coords.latitude,
      };
      // Instantiate (and display) a map object:
      var map = new H.Map(this.$refs.mapContainer, maptypes.normal.map, {
        zoom: 12,
        center: coords,
      });

      var userMarker = new H.map.Marker(coords);
      map.addObject(userMarker);
      userMarker.setZIndex(1000);

      this.mapObj = map;
      this.user = userMarker;
    },
  },
};
</script>
